//+------------------------------------------------------------------+
//|                                                    mandarine.mq4 |
//|                                     Copyright  2005, Nick Bilak |
//|                                        http://www.forex-tsd.com/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Nick Bilak"
#property link      "http://www.forex-tsd.com/"

#include <stdlib.mqh>

extern double  StopLoss = 35;  
extern double  TakeProfit = 120;  
extern double  TrailingStop = 35;  
extern int     slippage=2;   	//slippage for market order processing
extern int     shift=1;			//shift to current bar, 

extern string  AnalyzerSetting = "<<< Analyzer Setting >>>";
extern bool    ChartSymbolOnly = false;
extern int     SpecificMagic = 0;

extern string  KellySetting = "<<< Optimal f (Kelly) Setting >>>";
extern double  Fractional_Kelly = 0.25;
extern int     StopLoss_for_Kellylot = 100;

string SkipComment[];
int SkipComments;

int DQ_ADJUST[7] = { 0, 0, 1, 10, 1, 10, 100 };
int DQADJ, Ldig, DIGITS;
bool   buysig,sellsig; 
int    ttime,total;
string TradeSymbol;

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int ord;
//----
   total=OrdersTotal();
   for(int i=0;i<total;i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==SpecificMagic)
        {
         ord++;
        }
     }
//---- return orders volume
	return(ord);
  }
//+------------------------------------------------------------------+
//| Calculate Kelly Lot Size                                         |
//+------------------------------------------------------------------+
   double Kellylot()  { 
   double lot_min =MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max =MarketInfo(Symbol(),MODE_MAXLOT);
   double BUY_TRADES = Trades(0);
   double SELL_TRADES = Trades(1);
   double TOTAL_TRADES = BUY_TRADES + SELL_TRADES;
   DIGITS = MarketInfo(Symbol(),MODE_DIGITS);
   DQADJ = DQ_ADJUST [ DIGITS ];

   Ldig = 2;
   if(MarketInfo(Symbol(),MODE_MINLOT) > 0.07) Ldig = 1;
   if(MarketInfo(Symbol(),MODE_MINLOT) > 0.7) Ldig = 0;
   if(OrdersHistoryTotal() < 1 || TOTAL_TRADES < 0.9) {
// Statistics --------------------------------------

   double BUY_WINS = Wins(0); double BUY_LOSSES = BUY_TRADES - BUY_WINS; 
   double SELL_WINS = Wins(1); double SELL_LOSSES = SELL_TRADES - SELL_WINS; 
   double TOTAL_WINS = BUY_WINS + SELL_WINS; double TOTAL_LOSSES = TOTAL_TRADES - TOTAL_WINS; 

   // Winning Average
   double WinAv_Total = 0.0;
   if(TOTAL_TRADES > 0.001) WinAv_Total = TOTAL_WINS / TOTAL_TRADES;
   Print("Trades : " + DS0(TOTAL_TRADES) +" (Total) / "+DS0(BUY_TRADES) +" (buy) / "+DS0(SELL_TRADES) +" (sell)");


   // Average P/L
   double Buy_Profit = Profit(0);
   double Sell_Profit = Profit(1);
   double Total_Profit = Buy_Profit + Sell_Profit;
   double Buy_Loss = Loss(0);
   double Sell_Loss = Loss(1);
   double Total_Loss = Buy_Loss + Sell_Loss;

   double Av_Profit_Total = 0.0;
   if(TOTAL_WINS > 0.001) Av_Profit_Total = Total_Profit / TOTAL_WINS;

   double Av_Loss_Total = 0.0;
   if(TOTAL_LOSSES > 0.001) Av_Loss_Total = Total_Loss / TOTAL_LOSSES;

   double PL_RATIO_Total = 0.0;
   if(Av_Loss_Total > 0.001) PL_RATIO_Total = Av_Profit_Total / Av_Loss_Total;

   Print("Average Win : "+DS2(Av_Profit_Total) +" "+AccountCurrency());
   Print("Average Loss : "+DS2(Av_Loss_Total) +" "+AccountCurrency());
   Print("Profit / Loss Ratio : "+DS2(PL_RATIO_Total));


   // Optimal f (Kelly)
   
   double Optimal_f = 0.0;
   if(PL_RATIO_Total > 0.001) Optimal_f = ( (PL_RATIO_Total + 1) * WinAv_Total - 1 ) / PL_RATIO_Total;  
   Print("Optimal f (Kelly) : "+DS2(Optimal_f * 100) +"%");
      
   if(Fractional_Kelly < 0.9999) 
   string Fractional = ""; if(Fractional_Kelly < 0.9999) Fractional = ", Fractional";
   Print("Fractional Kelly ("+DS2(Fractional_Kelly)+") : "+DS2(Optimal_f*Fractional_Kelly*100) +"%");

//--- basic kelly formula
   double Kellylot = 0.0;
   if(StopLoss_for_Kellylot>0.001)
   Kellylot=(AccountBalance() * Optimal_f*Fractional_Kelly) / ( MarketInfo(Symbol(),MODE_TICKVALUE) * StopLoss_for_Kellylot * DQADJ );
   Print( "Risk by Optimal f : "+DoubleToStr(Kellylot,Ldig) +" lot (SL : "+StopLoss_for_Kellylot+"pips"+Fractional+")");


//--- check min, max Lot size
   if(Kellylot<lot_min) Kellylot = lot_min;
   if(Kellylot>lot_max) Kellylot=lot_max;
//---
   return(Kellylot);
  }
  }
//+------------------------------------------------------------------+
//| DS2 (string) double Val
//+------------------------------------------------------------------+
string DS2(double Val)
{
   return(DoubleToStr(Val,2));
}

//+------------------------------------------------------------------+
//| DS0 (string) double Val
//+------------------------------------------------------------------+
string DS0(double Val)
{
   return(DoubleToStr(Val,0));
}


//+------------------------------------------------------------------+
//| IsSkip (bool)
//+------------------------------------------------------------------+
bool IsSkip(string ORDERSYMBOL, int ORDERMAGIC, string ORDERCOMMENT, datetime ORDEROPENTIME, datetime ORDERCLOSETIME)
{
   if(ChartSymbolOnly && Symbol() != ORDERSYMBOL) return(true); // symbol check
   if(SpecificMagic > 0 && ORDERMAGIC != SpecificMagic) return(true); // magic check
   if( IsSkipComment( ORDERCOMMENT ) ) return(true); // comment check

   return(false);
}  

//+------------------------------------------------------------------+
//| IsSkipComment (bool)
//+------------------------------------------------------------------+
bool IsSkipComment(string OrdComment)
{
   bool IsSkipComment = false;
   for(int i=0; i<SkipComments; i++) if(StringFind(OrdComment, SkipComment[i]) != -1) IsSkipComment = true;

   return(IsSkipComment);
}  


//+------------------------------------------------------------------+
//| Trades (int)
//+------------------------------------------------------------------+  
int Trades(int ordType){
   int tradeCount = 0;

   for(int i=0; i<OrdersHistoryTotal(); i++){
      if( !OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) )continue; // select check
      if( OrderType() != ordType )continue; // order type check
      if( IsSkip( OrderSymbol(), OrderMagicNumber(), OrderComment(), OrderOpenTime(), OrderCloseTime()) )continue;
      tradeCount++;
   }
   return( tradeCount );
}
//+------------------------------------------------------------------+
//| Wins (int)
//+------------------------------------------------------------------+
int Wins(int ordType)
{
   int winsCount = 0;

   for(int i=0; i<OrdersHistoryTotal(); i++)
   {
      if( !OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) ) continue; // select check
      if( OrderType() != ordType ) continue; // order type check
      if( IsSkip( OrderSymbol(), OrderMagicNumber(), OrderComment(), OrderOpenTime(), OrderCloseTime()) ) continue;
      
      if(OrderProfit()+OrderSwap()+OrderCommission() >= 0) winsCount++;
   }

   return(winsCount);
}  

//+------------------------------------------------------------------+
//| Profit (double)
//+------------------------------------------------------------------+
double Profit(int ordType)
{
   double profitCount = 0.0;

   for(int i=0; i<OrdersHistoryTotal(); i++)
   {
      if( !OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) ) continue; // select check
      if( OrderType() != ordType ) continue; // order type check
      if( IsSkip( OrderSymbol(), OrderMagicNumber(), OrderComment(), OrderOpenTime(), OrderCloseTime()) ) continue;
      
      if(OrderProfit()+OrderSwap()+OrderCommission() >= 0) profitCount += (OrderProfit()+OrderSwap()+OrderCommission());
   }

   return(profitCount);
}

//+------------------------------------------------------------------+
//| Loss (double)
//+------------------------------------------------------------------+
double Loss(int ordType)
{
   double lossCount = 0.0;

   for(int i=0; i<OrdersHistoryTotal(); i++)
   {
      if( !OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) ) continue; // select check
      if( OrderType() != ordType ) continue; // order type check
      if( IsSkip( OrderSymbol(), OrderMagicNumber(), OrderComment(), OrderOpenTime(), OrderCloseTime()) ) continue;

      if(OrderProfit()+OrderSwap()+OrderCommission() < 0) lossCount -= (OrderProfit()+OrderSwap()+OrderCommission());
   }

   return(lossCount);
}
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForSignals(string symbol) {
      double high = iHigh(NULL,0,shift);
      double low = iLow(NULL,0,shift);
      double close = iClose(NULL,0,shift);
      double P = (high+low+close)/3;

      double Buy1_1 = Bid;
      double Buy1_2 = P;

      double Sell1_1 = Bid;
      double Sell1_2 = P;

	
      sellsig=false;
      buysig=false;
      //if (sell>0) {
      if (Sell1_1 <= Sell1_2) {
         sellsig=true;
      }
      //if (buy>0) {
      if (Buy1_1 >= Buy1_2) {
         buysig=true;
      }
}

void CheckForOpen(string symbol) {
   int    res;
//---- sell conditions
   if(sellsig && ttime!=Time[0])  {
      res=OrderSend(symbol,OP_SELL,Kellylot(),Bid,slippage,Bid+StopLoss*Point,Bid-TakeProfit*Point,"t3",SpecificMagic,0,Red);
      Print(symbol,OP_SELL,Kellylot(),Ask,slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,SpecificMagic );
   	if (res<0) Print("Error opening SELL order : ",ErrorDescription(GetLastError()));
      ttime=Time[0];
      return;
   }
//---- buy conditions
   if(buysig && ttime!=Time[0])  {
      res=OrderSend(symbol,OP_BUY,Kellylot(),Ask,slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,"t3",SpecificMagic,0,Blue);
      Print(symbol,OP_BUY,Kellylot(),Ask,slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,SpecificMagic );
   	if (res<0) Print("Error opening BUY order : ",ErrorDescription(GetLastError()));
      ttime=Time[0];
      return;
   }
}
  
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose(string symbol)  {
	total=OrdersTotal();
   for(int i=0;i<total;i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)  break;
      if(OrderMagicNumber()!=SpecificMagic || OrderSymbol()!=symbol) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if (sellsig) {
            OrderClose(OrderTicket(),OrderLots(),Bid,slippage,White);
         }
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if (buysig) {
            OrderClose(OrderTicket(),OrderLots(),Ask,slippage,White);
         }
         break;
        }
     }
}


//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()  {


   //---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;

	TradeSymbol=Symbol();

   //---- check for signals
   CheckForSignals(TradeSymbol);

   //---- calculate open orders by current symbol
   if (CalculateCurrentOrders(TradeSymbol)==0) 
      CheckForOpen(TradeSymbol);
   else
      CheckForClose(TradeSymbol);
	
	TrailStop(TradeSymbol);


}
//+------------------------------------------------------------------+

void TrailStop(string mySymbol) {
	double Pip = Point;
   if(Digits==3 || Digits==5) Pip = 10*Point;
   double StopLoss,trailing;
   if ( TrailingStop>=8 ) {
   	trailing=TrailingStop*Pip;
      for (int i = 0; i < OrdersTotal(); i++) {
         if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
         if ( OrderSymbol() != mySymbol || OrderMagicNumber() != SpecificMagic )  continue;
         if ( OrderType() == OP_BUY ) {
            StopLoss = Bid-trailing;
            if ( StopLoss > OrderStopLoss() ) {
               OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
            }
         }
   
         if ( OrderType() == OP_SELL ) {
            StopLoss = Ask+trailing;
            if ( StopLoss < OrderStopLoss() ) {
               OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
            }
         }
      }
   }
   return;
}

